<?php
/*
 * This file is part of a larger software package. Please read the License file 
 * in the root of this installation for terms of usage and distribution.
 * 
 * @author The Web Pro Miami, Inc. <info@thewebpro.com>
 * @copyright The Web Pro Miami, Inc. <info@thewebpro.com>, http://www.thewebpro.com/
 * 
 * CORE: manage/list/components.php - version 1.10
 * 1.10 - added JSON config file to components
*/

require("../inc/stop_cache.php");
$nAdminOnlyPg = 1;
// Secure and connect
require("../../inc/dbconnect.php");
require("../inc/secure_page.php");

// bring in other required files
require("../../inc/config.php");
require("../inc/lang.php");
include("../inc/paginator.php");
include("../inc/pageutil.php");
include("../inc/calendar.php");
require("../inc/langutil.php");

$nShowPerPg = 20;

$nCompPath = "../../comp/";

nUpdateCompList("../../comp"); // Update components list

// Clean out components that exist in database but not found in "comp" folder
////nCleanDiscardedComps();

// Get passed-in vars
if(isset($_GET["pg"])){ $nPage = $_GET["pg"]; } else { $nPage = ""; }
if(!$nPage && isset($_POST["pg"])){ $nPage = $_POST["pg"]; }
if(isset($_GET["srt"])){ $nSort = $_GET["srt"]; } else { $nSort = ""; }
if(isset($_GET["ord"])){ $nSortOrder = $_GET["ord"]; } else { $nSortOrder = ""; }
if(isset($_GET["spp"])){ $nShowPerPgOverride = $_GET["spp"]; } else { $nShowPerPgOverride = ""; }
if($nShowPerPgOverride){ $nShowPerPg = $nShowPerPgOverride; }

// Setup SQL query for displayed listing
if(!$nSort){ $nSort="nName"; }  // default sort
if(!$nSortOrder){ $nSortOrder="ASC"; }  // default sort order
// if($nUserID){ $nWhereARRAY[] = "nID='$nUserID'"; }

$nWhereSQL = "";
if(isset($nWhereARRAY)){ $nWhereSQL = "WHERE ".implode(" AND ",$nWhereARRAY); } else { $nWhereSQL = ""; }
$nOrderBySQL = "ORDER BY $nSort $nSortOrder";
$nListingSQL = "SELECT * From nComponent $nWhereSQL $nOrderBySQL";
?>
<div id="listContent" style="padding-top:0px;">
<?php
$nPassThru = "";
$nDivToUpdate = "ajaxComponents";
$nPageInDiv = "list/components.php";
$nCurrQueryStr = $_SERVER['QUERY_STRING'];
if($nCurrQueryStr){ $nFullPageInDiv = $nPageInDiv."?".$nCurrQueryStr; } else { $nFullPageInDiv = $nPageInDiv; }
$nPagingText = nGetPaging($nListingSQL,$nPage,$nShowPerPg,$nPassThru,$nDivToUpdate,$nPageInDiv);
if($nPassThru){ $nPassThruQry="?".$nPassThru; $nPassThru="&".$nPassThru; }
// for extrenal refresh requests
print "<script>refreshComps = function(){ loadContent('".$nDivToUpdate."','".$nFullPageInDiv."'); }</script>";
?>

<!--[if !IE]>start section inner<![endif]-->
<div class="section_inner">
	<!--[if !IE]>start table_wrapper<![endif]-->
	<div class="table_wrapper">
		<div class="table_wrapper_inner">
		<table cellpadding="0" cellspacing="0" width="100%">
			<tbody><tr>
				<th style="width:25px;"><?php echo _("No."); ?></th>
				<?$nSortFld="nName"; if($nSortFld==$nSort){ if($nSortOrder=="ASC"){ $nLink="?srt=$nSortFld&ord=DESC$nPassThru";$nSortClass=" class=\"asc\""; } else { $nLink="?srt=$nSortFld&ord=ASC$nPassThru";$nSortClass=" class=\"desc\""; } } else { $nLink="?srt=$nSortFld&ord=ASC$nPassThru";$nSortClass=""; }?>
				<th><a href="javascript:loadContent('<?php echo $nDivToUpdate?>','<?php echo $nPageInDiv.$nLink?>');"<?php echo $nSortClass;?>><?php echo _("Component Name"); ?></a></th>
				<?$nSortFld="nActive"; if($nSortFld==$nSort){ if($nSortOrder=="ASC"){ $nLink="?srt=$nSortFld&ord=DESC$nPassThru";$nSortClass=" class=\"asc\""; } else { $nLink="?srt=$nSortFld&ord=ASC$nPassThru";$nSortClass=" class=\"desc\""; } } else { $nLink="?srt=$nSortFld&ord=ASC$nPassThru";$nSortClass=""; }?>
				<th width="80" style="text-align:center;"><a href="javascript:loadContent('<?php echo $nDivToUpdate?>','<?php echo $nPageInDiv.$nLink?>');"<?php echo $nSortClass;?>><?php echo _("Active?"); ?></a></th>
				<th width="80" style="text-align:center;"><?php echo _("Usage"); ?></th>
				<th style="width:96px;"><?php echo _("Actions"); ?></th>
			</tr>
			<?php echo nGetCompList();?>
		</tbody></table>
		</div>
	</div>
	<!--[if !IE]>end table_wrapper<![endif]-->
</div>
<!--[if !IE]>end section inner<![endif]-->

<?php if($nTotalPg>1){ ?>
	<!--[if !IE]>start pagination<![endif]-->
	<div class="pagination">
		<?php echo $nPagingText;?>
	</div>
	<!--[if !IE]>end pagination<![endif]-->
<?php } else {?>
	<!--[if !IE]>start pagination<![endif]-->
	<div class="pagination">
		<span class="page_no">&nbsp;</span>
	</div>
	<!--[if !IE]>end pagination<![endif]-->
<?php } ?>


<?php
function nGetCompList(){
	global $DBName,$Link,$nListingSQL;
	global $nShowPerPg,$nTotalRec,$nStartRec,$nEndRec,$nTotalPg;
	if(!$nListingSQL){ return ""; }
	$nCurrRec = 0;
	$nTable = "";
	$nRowClass = "";
	mysql_select_db($DBName); $Result = mysql_query($nListingSQL,$Link);
	while($Row = mysql_fetch_array($Result)){
		$nCurrRec++;
		if($nCurrRec>=$nStartRec && $nCurrRec<=$nEndRec && $nCurrRec<=$nTotalRec){
			$nID = $Row["nID"];
			$nName = $Row["nName"];
			$nActive = $Row["nActive"];
			$nEditText = _("Edit");
			$nEnableText = _("Enable");
			$nDisableText = _("Disable");
			$nDisabledText = _("Disabled");
			$nEditItemText = _("Edit Component");
			$nToggleItemText = _("Toggle Component");
			$nPageUsage = nGetPageCount($nID);
			$nPageText = _("pages");
			if($nActive){
				$nActive = _("Active");
				//$nEditCODE = "<li><a class=\"modal edit\" href=\"dialog/component_files_edit.php?id=$nID\" title=\"$nEditItemText\">$nEditText</a></li>";
				$nEnableCODE = "<li><a class=\"modal delete\" href=\"dialog/component_toggle.php?id=$nID\" title=\"$nToggleItemText\">$nDisableText</a></li>";
			} else {
				$nActive="<span style=\"color:#AA0000;\">$nDisabledText</span>";
				//$nEditCODE = "<li><a class=\"modal edit\" href=\"dialog/component_files_edit.php?id=$nID\" title=\$nEditItemText\">$nEditText</a></li>";
				$nEnableCODE = "<li><a class=\"modal approve\" href=\"dialog/component_toggle.php?id=$nID\" title=\"$nToggleItemText\">$nEnableText</a></li>";
			}
			if(!$nName){ $nName="<span class=\"caption\"><em>&lt;"._("unnamed")."&gt;</em></span>"; }
			if($nRowClass=="second"){ $nRowClass="first"; } else { $nRowClass="second"; }
			$nTable.= <<<CODE
			<tr id="row$nCurrRec" class="$nRowClass" onMouseOver="$('#row$nCurrRec').addClass('rowhilite');" onMouseOut="$('#row$nCurrRec').removeClass('rowhilite');">
				<td>$nCurrRec.</td>
				<td><strong>$nName</strong></td>
				<td align="center" style="text-align: center;">$nActive</td>
				<td align="center" style="text-align:center;">$nPageUsage $nPageText</td>
				<td>
					<div class="actions_menu" style="margin:6px 0;">
						<ul>
							$nEnableCODE
						</ul>
					</div>
				</td>
			</tr>
CODE;
		}
	}
	if(!$nTable){ $nTable = "<tr id=\"$nRowClass\"><td height=\"200\" align=\"center\" class=\"caption\" colspan=\"5\"><em>"._("No data available to display.")."</em></td></tr>"; }
	return $nTable;
}

function nGetPageCount($nCompID){
	global $DBName,$Link;
	if($nCompID===""){ return 0; }
	$nNumRecords = 0;
	$nSQL = "SELECT nPageID FROM xComponentPage WHERE nComponentID='$nCompID' GROUP BY nPageID";
	mysql_select_db($DBName); $Result = mysql_query($nSQL,$Link);
	$nNumRecords = mysql_num_rows($Result);
	return $nNumRecords;
}

// to capture calls and prevent errors from included comp, but not needed to run now
function addField($nFldID="",$nTitle="",$nCaption="",$nDefVal="",$nCustFuncMan="",$nCustFuncSite=""){
	return;
}

function nUpdateCompList($nDirectory = ""){
	global $DBName,$Link,$nAllFieldARRAY,$nCompPath;
	
	$nExcludeDirARRAY = array("de","en","es","fr","img","inc","it","nav","pt","sb");
	
	// For legacy comps, set default categories
	$nCompCatARRAY = array();
	// Tournament
	$nCompCatARRAY["latest_personal_catches_table"] = "Tournament";
	$nCompCatARRAY["latest_team_catches_table"] = "Tournament";
	$nCompCatARRAY["latest_tournament_catches_table"] = "Tournament";
	$nCompCatARRAY["personal_stats_by_tournament_refresh"] = "Tournament";
	$nCompCatARRAY["team_stats_by_tournament_refresh"] = "Tournament";
	$nCompCatARRAY["tournament_angler_list"] = "Tournament";
	$nCompCatARRAY["tournament_angler_stats_table"] = "Tournament";
	$nCompCatARRAY["tournament_clock"] = "Tournament";
	$nCompCatARRAY["tournament_control_bar"] = "Tournament";
	$nCompCatARRAY["tournament_division_standings_refresh"] = "Tournament";
	$nCompCatARRAY["tournament_info"] = "Tournament";
	$nCompCatARRAY["tournament_list"] = "Tournament";
	$nCompCatARRAY["tournament_news_ticker"] = "Tournament";
	$nCompCatARRAY["tournament_species_division_standings_refresh"] = "Tournament";
	$nCompCatARRAY["tournament_sponsors"] = "Tournament";
	$nCompCatARRAY["tournament_stats"] = "Tournament";
	$nCompCatARRAY["tournament_team_list"] = "Tournament";
	$nCompCatARRAY["tournament_team_standings_refresh"] = "Tournament";
	$nCompCatARRAY["tournament_team_stats_table"] = "Tournament";
	// Series
	$nCompCatARRAY["series_angler_stats_table"] = "Series";
	$nCompCatARRAY["personal_stats_by_series_refresh"] = "Series";
	$nCompCatARRAY["series_division_standings_refresh"] = "Series";
	$nCompCatARRAY["series_info"] = "Series";
	$nCompCatARRAY["series_list"] = "Series";
	$nCompCatARRAY["series_navbox"] = "Series";
	$nCompCatARRAY["series_sponsors"] = "Series";
	$nCompCatARRAY["series_stats"] = "Series";
	$nCompCatARRAY["series_team_standings_refresh"] = "Series";
	$nCompCatARRAY["series_team_stats_table"] = "Series";
	$nCompCatARRAY["team_stats_by_series_refresh"] = "Series";
	// Miscellaneous
	$nCompCatARRAY["angler_info"] = "Miscellaneous";
	$nCompCatARRAY["team_info"] = "Miscellaneous";
	$nCompCatARRAY["boat_info"] = "Miscellaneous";
	// General
	$nCompCatARRAY["basicnavbox"] = "General";
	$nCompCatARRAY["featuretext"] = "General";
	$nCompCatARRAY["headerimage"] = "General";
	$nCompCatARRAY["image_slideshow"] = "General";
	$nCompCatARRAY["imagegallery"] = "General";
	$nCompCatARRAY["pdfnavbox"] = "General";
	$nCompCatARRAY["search_results"] = "General";
	$nCompCatARRAY["simpleimage"] = "General";
	$nCompCatARRAY["simpletext"] = "General";
	$nCompCatARRAY["text"] = "General";
	$nCompCatARRAY["textimage"] = "General";
	$nCompCatARRAY["title"] = "General";
	// Forms
	$nCompCatARRAY["contactform"] = "Forms";
	$nCompCatARRAY["disqus_commentbox"] = "Forms";
	$nCompCatARRAY["loginform"] = "Forms";
	$nCompCatARRAY["manual_event_form_ckf"] = "Forms";
	$nCompCatARRAY["regform"] = "Forms";
	
	// Get all files in Components directory
	$nRecursive = true;
	if($nDirectory && is_dir($nDirectory)){
		$nDirHandle = @opendir($nDirectory) or die("Unable to open Component path: $nDirectory");
		for($list = array(); (FALSE !== ($nFileName = readdir($nDirHandle)));){
			if(($nFileName != '.' && $nFileName != '..') && !in_array($nFileName,$nExcludeDirARRAY) && (file_exists($path = $nDirectory.'/'.$nFileName))){
				if(is_dir($path) && ($nRecursive)){
					$list = array_merge($list, nUpdateCompList($path));
				} else {
					$entry = array('filename' => $nFileName, 'dirpath' => $nDirectory);
					
					// For all files and directories in this folder...
					do if(!is_dir($path)){
						// For all files, import if a valid component is located here
						$nCompName = strtolower(pathinfo($nFileName,PATHINFO_FILENAME));
						$nFileExt = strtolower(pathinfo($nFileName,PATHINFO_EXTENSION));
						$nFilePath = $nDirectory."/".$nFileName;
						
						// For legacy components, pull in their PHP config files and build a JSON file + comp folder if they don't already have one
						// *** Can and SHOULD be removed in a future version (after v1.04) once all old components have a JSON config file
						if(file_exists("$nFilePath") && $nFileExt=="php" && !file_exists($nDirectory."/".$nCompName.".json")){
							$nName = $nDescription = $nPageTypeLimit = $nTemplateFile = "";
							$nAllFieldARRAY = array();
							include_once("$nFilePath");
							$nCompInfoARRAY = array();
							$nCompInfoARRAY["name"] = $nName;
							$nCompInfoARRAY["version"] = "1.0";
							$nCompInfoARRAY["description"] = $nDescription;
							$nCompInfoARRAY["basefile"] = $nFileName;
							$nCompInfoARRAY["category"] = "General";
							if(isset($nCompCatARRAY[$nCompName])){ $nCompInfoARRAY["category"] = $nCompCatARRAY[$nCompName]; }
							$nCompInfoARRAY["icon"] = $nCompName.".png";
							$nCompInfoARRAY["page_type_limit"] = $nPageTypeLimit;
							$nCompInfoARRAY["template_basefile"] = $nTemplateFile;
							$nCompInfoARRAY["scripts"]["css"] = "";
							$nCompInfoARRAY["scripts"]["js"] = "";
							$nCompInfoARRAY["fields"] = $nAllFieldARRAY;
							$nCompJSON = json_encode($nCompInfoARRAY);
							$nCompJSON = nFormatJSON($nCompJSON);
							
							// Create directory for old comp and move basefile/template into it
							if(!is_dir("$nCompPath$nCompName")){
								if(mkdir("$nCompPath$nCompName",0755)){
									if(file_exists("$nCompPath$nFileName")){ rename("$nCompPath$nFileName",$nCompPath.$nCompName."/".$nFileName); }
									if(file_exists("$nCompPath$nTemplateFile")){ rename("$nCompPath$nTemplateFile",$nCompPath.$nCompName."/".$nTemplateFile); }
								} else {
									exit("Cannot write to 'comp' folder! Please update your access to the folder to allow write access (755).");
								}
							}
							
							$nFilePath = $nCompPath.$nCompName."/".$nCompName.".json";
							file_put_contents($nFilePath,$nCompJSON); // Save file
							nImportCompByJSONFile($nFilePath); // Import component, if needed
						}
						
						// Process existing JSON config files (saves or updates component, if needed)
						if(file_exists("$nFilePath") && $nFileExt=="json"){ nImportCompByJSONFile($nFilePath); }
						
						break;
					} else {
						// Actions to be performed on directories only
						break;
					} while (false);
					$list[] = $entry;
				}
			}
		}
		closedir($nDirHandle);
		return $list;
	} else {
		return false;
	}
}

// Capture calls from legacy comps and build JSON for config file
function addField($nFldID="",$nTitle="",$nCaption="",$nDefVal="",$nFldStyle="",$nCustFuncMan="",$nCustFuncSite=""){
	global $nAllFieldARRAY;
	$nAllFieldARRAY[] = array(
		"type" => $nFldID,
		"group" => "",
		"title" => $nTitle,
		"caption" => $nCaption,
		"default_value" => $nDefVal,
		"style" => $nFldStyle,
		"custom_function" => array(
			"manager" => $nCustFuncMan,
			"site" => $nCustFuncSite
		)
	);
}

// Imports JSON config file for a component and adds it to database if out-of-version or is non-existent
function nImportCompByJSONFile($nFilePath){
	global $DBName,$Link;
	if(!$nFilePath){ return; }
	if(file_exists("$nFilePath")){
		// Import file and convert to array with json_decode
		$nCompARRAY = array();
		$nCompARRAY = json_decode(file_get_contents($nFilePath),true);
		$nName = $nVersion = $nDescription = $nPageTypeLimit = $nBaseFileName = "";
		if(isset($nCompARRAY["name"])){ $nName = $nCompARRAY["name"]; }
		if(isset($nCompARRAY["version"])){ $nVersion = $nCompARRAY["version"]; }
		if(isset($nCompARRAY["description"])){ $nDescription = $nCompARRAY["description"]; }
		if(isset($nCompARRAY["page_type_limit"])){ $nPageTypeLimit = $nCompARRAY["page_type_limit"]; }
		if(isset($nCompARRAY["basefile"])){ $nBaseFileName = $nCompARRAY["basefile"]; }
		if(isset($nCompARRAY["icon"])){ $nIcon = $nCompARRAY["icon"]; }
		if(isset($nCompARRAY["category"])){ $nCategory = $nCompARRAY["category"]; }
		$nName = addslashes(stripslashes($nName));
		$nCategory = addslashes(stripslashes($nCategory));
		$nDescription = addslashes(stripslashes($nDescription));
		if($nBaseFileName && $nVersion){
			// Check if comp exists in database and if version is the same
			$nCompID = nGetCompIDFromBaseFile($nBaseFileName,$nVersion);
			if(!$nCompID){
				// If comp doesn't exist or is a different version, remove existing comp record (if any)
				$Query = "DELETE FROM nComponent WHERE nCompFile='$nBaseFileName'";
				mysql_select_db($DBName); mysql_query($Query, $Link);
				// Add new comp record
				$Query = "INSERT INTO nComponent (nName,nVersion,nDesc,nActive,nTypeLimit,nCompFile,nCategory,nIcon) VALUES ('$nName','$nVersion','$nDescription','1','$nPageTypeLimit','$nBaseFileName','$nCategory','$nIcon')";
				mysql_select_db($DBName); mysql_query($Query, $Link);
			}
		}
	}
}

function nGetCompIDFromBaseFile($nBaseFile,$nVersion="1.0"){
	global $DBName, $Link;
	if(!$nBaseFile){ return; }
	$nID = "";
	$Query = "SELECT nID FROM nComponent WHERE nCompFile='$nBaseFile' AND nVersion='$nVersion'";
	mysql_select_db($DBName); $Result = mysql_query($Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nID = $Row["nID"];
	}
	return $nID;
}

function nGetCompIDFromName($nCompName){
	global $DBName, $Link;
	if(!$nCompName){ return; }
	$nID = "";
	$Query = "SELECT nID FROM nComponent WHERE nName='$nCompName'";
	mysql_select_db($DBName); $Result = mysql_query($Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nID = $Row["nID"];
	}
	return $nID;
}

function nTruncateString($nStr,$nMax){
  if(strlen($nStr)>$nMax) {
    $leave = $max - strlen($rep);
    return substr($nStr,0,$nMax);
  }
  return $nStr;
}
function nGetCompIDFromTemplateFile($nCompTmplFile){
	global $DBName, $Link;
	if(!$nCompTmplFile){ return; }
	$nID = "";
	$Query = "SELECT nID FROM nComponent WHERE nCompFile='$nCompTmplFile'";
	mysql_select_db($DBName); $Result = mysql_query($Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nID = $Row["nID"];
	}
	return $nID;
}
function nCleanDiscardedComps(){
	global $DBName,$Link;
	global $nCompPath;
	$dir_handle = @opendir($nCompPath) or die("Unable to open Component path: $nCompPath");
	$Query = "SELECT nPluginID FROM nPlugins";
	mysql_select_db($DBName); $Result = mysql_query($Query,$Link);
	$nCurrentRecord = 0;
	while ($Row = mysql_fetch_array($Result)) {
		$nPluginID = $Row["nPluginID"];
		$nMasterFilePath = "$nCompPath$nPluginID/$nPluginID.php";
		if(!is_dir("$nCompPath$nPluginID/") || !file_exists("$nMasterFilePath")){
			nDeletePlugin($nPluginID);
		}
	}
	closedir($dir_handle);
	return;
}
function nDeletePlugin($nPluginID){
	global $DBName,$Link;
	global $nCompPath;
	if(!$nPluginID){ return; }
	$nMasterPluginPath = "$nCompPath$nPluginID/";
	// Remove folder
	if(is_dir("$nMasterPluginPath")){ nRecursiveDelete("$nMasterPluginPath"); }
	// Remove record
	$Query = "DELETE FROM nPlugins WHERE nPluginID='$nPluginID' LIMIT 1";
	mysql_select_db($DBName);
	mysql_query($Query, $Link);
	// Remove all associated databases
	mysql_select_db($DBName);
	$Query = "SHOW TABLES FROM $DBName";
	$result = mysql_query($Query);
	while ($Row = mysql_fetch_row($result)) {
	    $nTableName = $Row[0];
		$pos = strpos($nTableName, $nPluginID);
		if($pos !== false){
			// Remove record
			$Query = "DROP TABLE IF EXISTS $nTableName";
			mysql_select_db($DBName);
			mysql_query($Query, $Link);
		}
	}
	// REMOVE all associated navigation items
	$Query = "DELETE FROM nPluginNav WHERE nPluginID='$nPluginID'";
	mysql_select_db($DBName);
	mysql_query($Query, $Link);
	// REMOVE all associated inclusion points
	$Query = "DELETE FROM nPluginInclusionPoint WHERE nPluginID='$nPluginID'";
	mysql_select_db($DBName);
	mysql_query($Query, $Link);
}
function nRecursiveDelete($str){
	if(is_file($str)){
		return @unlink($str);
	} elseif(is_dir($str)){
		$scan = glob(rtrim($str,'/').'/*');
		foreach($scan as $index=>$path){
			nRecursiveDelete($path);
		}
		return @rmdir($str);
	}
}
?>
<?php require("../../inc/db_close.php"); ?>
